//by Dr. Amin Danial

#include "HID-Project.h"

#define Default_Channels 2

unsigned char rawhidData[64],datasend[64],datarecv[64],i=0,flg=0,ch=Default_Channels;
unsigned int dta=0,temp,temp1;
unsigned long cur_instant = 0;

void setup() {
  // Set the RawHID OUT report array.
  // Feature reports are also (parallel) possible, see the other example for this.
  RawHID.begin(rawhidData, sizeof(rawhidData));
}

void loop() 
{
  auto bytesAvailable = RawHID.available(); // Check if there is new data from the RawHID device
  if (bytesAvailable)
  {   
    i=0;
    while (bytesAvailable)
    {
      datarecv[i]=RawHID.read();
      bytesAvailable--;
      i++;
    }

    if (datarecv[1])
      flg=1;
    else
    {
      if (datarecv[0]>2 || datarecv[0]<1)
        ch=Default_Channels;
      else
        ch=datarecv[0];
    }
  }
  
  // Recording the sampling time.
  cur_instant = millis();

  // Sampling the Analog channels******************* 
  dta=analogRead(A0);
  datasend[0]=(unsigned char)(dta%256);
  datasend[1]=(unsigned char)(dta/256);
  if (ch==2)
  {
    dta=analogRead(A1);
    datasend[2]=(unsigned char)(dta%256);
    datasend[3]=(unsigned char)(dta/256);
  }
  // Sending the sampling time
  temp=(unsigned int)(cur_instant%((unsigned long)65536));
  temp1=(unsigned int)(cur_instant/((unsigned long)65536));
  datasend[4]=(unsigned char)(temp%256);
  datasend[5]=(unsigned char)(temp/256);
  datasend[6]=(unsigned char)(temp1%256);
  datasend[7]=(unsigned char)(temp1/256);
  //*************************************************
  if(flg)
  {
    RawHID.write(datasend,8); // sending data array)
    flg=0;
  }
  //*************************************************
}
